unit chartfrm;

interface

uses
  {$IFNDEF FPC}Windows, {$ELSE}LResources, {$ENDIF} SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, dx_objects, dx_scene, dx_utils, dx_controls, dx_vgcore,
  dx_vglayer;

type
  TForm9 = class(TForm)
    dxScene1: TdxScene;
    Root1: TdxVisualObject;
    Camera1: TdxCamera;
    Light1: TdxLight;
    Grid1: TdxGrid;
    Cube1: TdxCube;
    Cube2: TdxCube;
    Cube3: TdxCube;
    Cube4: TdxCube;
    Grid2: TdxGrid;
    Grid3: TdxGrid;
    cameraz: TdxDummy;
    camerax: TdxDummy;
    Cylinder1: TdxCylinder;
    Cylinder2: TdxCylinder;
    Cylinder3: TdxCylinder;
    Cylinder4: TdxCylinder;
    Cone1: TdxCone;
    Cone2: TdxCone;
    Cone3: TdxCone;
    Cone4: TdxCone;
    GUIObjectLayer1: TdxGUIObjectLayer;
    Root2: TvxLayout;
    Rectangle1: TvxRectangle;
    HudButton1: TvxHudButton;
    procedure dxScene1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure dxScene1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure dxScene1MouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure HudButton1Click(Sender: TObject);
  private
    { Private declarations }
    Down: TdxPoint;
  public
    { Public declarations }
  end;

var
  Form9: TForm9;

implementation

{$R *.dfm}

procedure TForm9.FormCreate(Sender: TObject);
begin
  HudButton1Click(Self);
end;

procedure TForm9.dxScene1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Down := dxPoint(X, Y, 0);
end;

procedure TForm9.dxScene1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if ssRight in Shift then
  begin
    cameraz.RotateAngle.Z := cameraz.RotateAngle.Z + (X - Down.X);
    camerax.RotateAngle.X := camerax.RotateAngle.X + (Y - Down.Y);
    Down := dxPoint(X, Y, 0);
  end;
end;

procedure TForm9.dxScene1MouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
  Camera1.Position.Vector := dxVectorAdd(Camera1.Position.Vector, dxVectorScale(dxVector(0, 1, 0),
    (WheelDelta{$ifndef FPC}/30{$endif}) * 0.3));
end;

procedure TForm9.HudButton1Click(Sender: TObject);
var
  NewSize: single;
begin
  NewSize := 1 + random(8);
  Cube1.AnimateFloat('Depth', NewSize);
  Cube1.AnimateFloat('Position.Z', NewSize / 2);
  NewSize := 1 + random(8);
  Cube2.AnimateFloat('Depth', NewSize);
  Cube2.AnimateFloat('Position.Z', NewSize / 2);
  NewSize := 1 + random(8);
  Cube3.AnimateFloat('Depth', NewSize);
  Cube3.AnimateFloat('Position.Z', NewSize / 2);
  NewSize := 1 + random(8);
  Cube4.AnimateFloat('Depth', NewSize);
  Cube4.AnimateFloat('Position.Z', NewSize / 2);

  NewSize := 1 + random(8);
  Cylinder1.AnimateFloat('Width', NewSize);
  Cylinder1.AnimateFloat('Position.Z', NewSize / 2);
  NewSize := 1 + random(8);
  Cylinder2.AnimateFloat('Width', NewSize);
  Cylinder2.AnimateFloat('Position.Z', NewSize / 2);
  NewSize := 1 + random(8);
  Cylinder3.AnimateFloat('Width', NewSize);
  Cylinder3.AnimateFloat('Position.Z', NewSize / 2);
  NewSize := 1 + random(8);
  Cylinder4.AnimateFloat('Width', NewSize);
  Cylinder4.AnimateFloat('Position.Z', NewSize / 2);

  NewSize := 1 + random(8);
  Cone1.AnimateFloat('Width', NewSize);
  Cone1.AnimateFloat('Position.Z', NewSize / 2);
  NewSize := 1 + random(8);
  Cone2.AnimateFloat('Width', NewSize);
  Cone2.AnimateFloat('Position.Z', NewSize / 2);
  NewSize := 1 + random(8);
  Cone3.AnimateFloat('Width', NewSize);
  Cone3.AnimateFloat('Position.Z', NewSize / 2);
  NewSize := 1 + random(8);
  Cone4.AnimateFloat('Width', NewSize);
  Cone4.AnimateFloat('Position.Z', NewSize / 2);
end;

end.
